program/urls.py
import os

from django.conf import settings
from django.conf.urls import url
from django.views.decorators.cache import cache_page
from django.views.static import serve

from .views import DayScheduleView, WeekScheduleView, CurrentShowBoxView, HostListView, HostDetailView, RecommendationsListView, \
    RecommendationsBoxView, ShowListView, ShowDetailView, TimeSlotDetailView, StylesView

PROGRAM_SITE_MEDIA = os.path.join(os.path.dirname(__file__), '../site_media')

urlpatterns = [
    url(r'^today/?$', DayScheduleView.as_view()),
    url(r'^week/?$', WeekScheduleView.as_view()),
    url(r'^(?P<year>\d{4})/(?P<month>\d{1,2})/(?P<day>\d{1,2})/?$', DayScheduleView.as_view()),
    url(r'^(?P<year>\d{4})/(?P<week>\d{1,2})/?$', WeekScheduleView.as_view()),
    url(r'^current_box/?$', cache_page(60)(CurrentShowBoxView.as_view())),
    url(r'^hosts/?$', HostListView.as_view()),
    url(r'^hosts/(?P<pk>\d+)/?$', HostDetailView.as_view(), name='host-detail'),
    url(r'^tips/?$', RecommendationsListView.as_view()),
    url(r'^tips_box/?$', RecommendationsBoxView.as_view()),
    url(r'^shows/?$', ShowListView.as_view()),
    url(r'^shows/(?P<slug>[\w-]+)/?$', ShowDetailView.as_view(), name='show-detail'),
    url(r'^(?P<pk>\d+)/?$', TimeSlotDetailView.as_view(), name='timeslot-detail'),
    url(r'^styles.css$', StylesView.as_view())
]

if settings.DEBUG:
    urlpatterns.append(url(r'^static/(?P<path>.*)$', serve, {'document_root': PROGRAM_SITE_MEDIA}))

pv/urls.py
from django.conf import settings
from django.conf.urls import url, include
from django.contrib import admin
from django.views.static import serve

from program.views import json_day_schedule, json_timeslots_specials

admin.autodiscover()

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^program/', include('program.urls')),
    url(r'^nop', include('nop.urls')),
    url(r'^tinymce/', include('tinymce.urls')),
    url(r'^export/day_schedule/(?P<year>\d{4})/(?P<month>\d{1,2})/(?P<day>\d{1,2})/$', json_day_schedule),
    url(r'^export/timeslots_specials.json$', json_timeslots_specials)
]

if settings.DEBUG:
    urlpatterns.append(url(r'^site_media/(?P<path>.*)$', serve, {'document_root': settings.MEDIA_ROOT}))

program/models.py
from datetime import date, datetime, time, timedelta

from dateutil.relativedelta import relativedelta
from dateutil.rrule import rrule
from django.contrib.auth.models import User
from django.core.exceptions import ObjectDoesNotExist, ValidationError, MultipleObjectsReturned
from django.db import models
from django.db.models import Q
from django.urls import reverse
from django.utils.translation import ugettext_lazy as _
from tinymce import models as tinymce_models

from .utils import get_automation_id_choices


class BroadcastFormat(models.Model):
    format = models.CharField(_("Format"), max_length=32)
    slug = models.SlugField(_("Slug"), max_length=32, unique=True)
    color = models.CharField(_("Color"), max_length=7, default='#ffffff')
    text_color = models.CharField(_("Text color"), max_length=7, default='#000000')
    enabled = models.BooleanField(_("Enabled"), default=True)

    class Meta:
        ordering = ('format',)
        verbose_name = _("Broadcast format")
        verbose_name_plural = _("Broadcast formats")

    def admin_color(self):
        return u'<span style="background-color: %s; color: %s; padding: 0.2em">%s/%s</span>' % (
            self.color, self.text_color, self.color, self.text_color)

    admin_color.short_description = _("Color")
    admin_color.allow_tags = True

    def __unicode__(self):
        return u'%s' % self.format


class ShowInformation(models.Model):
    information = models.CharField(_("Information"), max_length=32)
    abbrev = models.CharField(_("Abbreviation"), max_length=4, unique=True)
    slug = models.SlugField(_("Slug"), max_length=32, unique=True)
    button = models.ImageField(_("Button image"), blank=True, null=True, upload_to='buttons')
    button_hover = models.ImageField(_("Button image (hover)"), blank=True, null=True, upload_to='buttons')
    big_button = models.ImageField(_("Big button image"), blank=True, null=True, upload_to='buttons')

    class Meta:
        ordering = ('information',)
        verbose_name = _("Show information")
        verbose_name_plural = _("Show information")

    def admin_buttons(self):
        buttons = []
        if self.button:
            buttons.append(u'<img src="%s" />' % self.button.url)
        else:
            buttons.append(u'x')

        if self.button_hover:
            buttons.append(u'<img src="%s" />' % self.button_hover.url)
        else:
            buttons.append(u'x')

        if self.big_button:
            buttons.append(u'<img src="%s" />' % self.big_button.url)
        else:
            buttons.append(u'x')

        return ' '.join(buttons)

    admin_buttons.short_description = _("Buttons")
    admin_buttons.allow_tags = True

    def button_url(self):
        if self.button:
            return self.button.url
        else:
            return '/site_media/buttons/default-11.png'

    def button_hover_url(self):
        if self.button_hover:
            return self.button_hover.url
        else:
            return '/site_media/buttons/default-11.png'

    def big_button_url(self):
        if self.big_button:
            return self.big_button.url
        else:
            return '/site_media/buttons/default-17.png'

    def __unicode__(self):
        return u'%s' % self.information


class ShowTopic(models.Model):
    topic = models.CharField(_("Show topic"), max_length=32)
    abbrev = models.CharField(_("Abbreviation"), max_length=4, unique=True)
    slug = models.SlugField(_("Slug"), max_length=32, unique=True)
    button = models.ImageField(_("Button image"), blank=True, null=True, upload_to='buttons')
    button_hover = models.ImageField(_("Button image (hover)"), blank=True, null=True, upload_to='buttons')
    big_button = models.ImageField(_("Big button image"), blank=True, null=True, upload_to='buttons')

    class Meta:
        ordering = ('topic',)
        verbose_name = _("Show topic")
        verbose_name_plural = _("Show topics")

    def admin_buttons(self):
        buttons = []
        if self.button:
            buttons.append(u'<img src="%s" />' % self.button.url)
        else:
            buttons.append(u'x')

        if self.button_hover:
            buttons.append(u'<img src="%s" />' % self.button_hover.url)
        else:
            buttons.append(u'x')

        if self.big_button:
            buttons.append(u'<img src="%s" />' % self.big_button.url)
        else:
            buttons.append(u'x')

        return ' '.join(buttons)

    admin_buttons.short_description = _("Buttons")
    admin_buttons.allow_tags = True

    def button_url(self):
        if self.button:
            return self.button.url
        else:
            return '/site_media/buttons/default-11.png'

    def button_hover_url(self):
        if self.button_hover:
            return self.button_hover.url
        else:
            return '/site_media/buttons/default-11.png'

    def big_button_url(self):
        if self.big_button:
            return self.big_button.url
        else:
            return '/site_media/buttons/default-17.png'

    def __unicode__(self):
        return u'%s' % self.topic


class MusicFocus(models.Model):
    focus = models.CharField(_("Focus"), max_length=32)
    abbrev = models.CharField(_("Abbreviation"), max_length=4, unique=True)
    slug = models.SlugField(_("Slug"), max_length=32, unique=True)
    button = models.ImageField(_("Button image"), blank=True, null=True, upload_to='buttons')
    button_hover = models.ImageField(_("Button image (hover)"), blank=True, null=True, upload_to='buttons')
    big_button = models.ImageField(_("Big button image"), blank=True, null=True, upload_to='buttons')

    class Meta:
        ordering = ('focus',)
        verbose_name = _("Music focus")
        verbose_name_plural = _("Music focus")

    def admin_buttons(self):
        buttons = []
        if self.button:
            buttons.append(u'<img src="%s" />' % self.button.url)
        else:
            buttons.append(u'x')

        if self.button_hover:
            buttons.append(u'<img src="%s" />' % self.button_hover.url)
        else:
            buttons.append(u'x')

        if self.big_button:
            buttons.append(u'<img src="%s" />' % self.big_button.url)
        else:
            buttons.append(u'x')

        return ' '.join(buttons)

    admin_buttons.short_description = _("Buttons")
    admin_buttons.allow_tags = True

    def button_url(self):
        if self.button:
            return self.button.url
        else:
            return '/site_media/buttons/default-11.png'

    def button_hover_url(self):
        if self.button_hover:
            return self.button_hover.url
        else:
            return '/site_media/buttons/default-11.png'

    def big_button_url(self):
        if self.big_button:
            return self.big_button.url
        else:
            return '/site_media/buttons/default-17.png'

    def __unicode__(self):
        return u'%s' % self.focus


class Host(models.Model):
    name = models.CharField(_("Name"), max_length=128)
    is_always_visible = models.BooleanField(_("Is always visible"), default=False)
    email = models.EmailField(_("E-Mail"), blank=True)
    website = models.URLField(_("Website"), blank=True)

    class Meta:
        ordering = ('name',)
        verbose_name = _("Host")
        verbose_name_plural = _("Hosts")

    def __unicode__(self):
        return u'%s' % self.name

    def get_absolute_url(self):
        return reverse('host-detail', args=[str(self.id)])

    def active_shows(self):
        return self.shows.filter(programslots__until__gt=datetime.today())


class Show(models.Model):
    predecessor = models.ForeignKey('self', blank=True, null=True, related_name='successors', verbose_name=_("Predecessor"))
    hosts = models.ManyToManyField(Host, blank=True, related_name='shows', verbose_name=_("Hosts"))
    owners = models.ManyToManyField(User, blank=True, related_name='shows', verbose_name=_("Owners"))
    broadcastformat = models.ForeignKey(BroadcastFormat, related_name='shows', verbose_name=_("Broadcast format"))
    showinformation = models.ManyToManyField(ShowInformation, blank=True, related_name='shows',
                                             verbose_name=_("Show information"))
    showtopic = models.ManyToManyField(ShowTopic, blank=True, related_name='shows', verbose_name=_("Show topic"))
    musicfocus = models.ManyToManyField(MusicFocus, blank=True, related_name='shows', verbose_name=_("Music focus"))
    name = models.CharField(_("Name"), max_length=255)
    slug = models.CharField(_("Slug"), max_length=255, unique=True)
    image = models.ImageField(_("Image"), blank=True, null=True, upload_to='show_images')
    image_enabled = models.BooleanField(_("show Image"), default=True)
    short_description = models.CharField(_("Short description"), max_length=64)
    description = tinymce_models.HTMLField(_("Description"), blank=True, null=True)
    email = models.EmailField(_("E-Mail"), blank=True, null=True)
    website = models.URLField(_("Website"), blank=True, null=True)
    created = models.DateTimeField(auto_now_add=True, editable=False)
    last_updated = models.DateTimeField(auto_now=True, editable=False)

    class Meta:
        ordering = ('slug',)
        verbose_name = _("Show")
        verbose_name_plural = _("Shows")

    def __unicode__(self):
        return u'%04d | %s' % (self.id, self.name)

    def get_absolute_url(self):
        return reverse('show-detail', args=[self.slug])

    def active_programslots(self):
        return self.programslots.filter(until__gt=date.today())


class RRule(models.Model):
    FREQ_CHOICES = (
        (1, _("Monthly")),
        (2, _("Weekly")),
        (3, _("Daily")),
    )
    BYSETPOS_CHOICES = (
        (1, _("First")),
        (2, _("Second")),
        (3, _("Third")),
        (4, _("Fourth")),
        (5, _("Fifth")),
        (-1, _("Last")),
    )
    name = models.CharField(_("Name"), max_length=32, unique=True)

program/forms.py
from django.core.files.images import get_image_dimensions
from django.forms import ModelForm, ValidationError

from program.models import MusicFocus, ShowInformation, ShowTopic


class FormWithButton(ModelForm):
    def clean_button(self):
        button = self.cleaned_data.get('button')
        if button:
            width, height = get_image_dimensions(button)
            if width != 11 or height != 11:
                raise ValidationError("width or height is not 11, (11x11)")
        return button

    def clean_button_hover(self):
        button_hover = self.cleaned_data.get('button_hover')
        if button_hover:
            width, height = get_image_dimensions(button_hover)
            if width != 11 or height != 11:
                raise ValidationError("width or height is not 11, (11x11)")
        return button_hover

    def clean_big_button(self):
        big_button = self.cleaned_data.get('big_button')
        if big_button:
            width, height = get_image_dimensions(big_button)
            if width != 17 or height != 17:
                raise ValidationError("width or height is not 17, (17x17)")
        return big_button


class MusicFocusForm(FormWithButton):
    class Meta:
        model = MusicFocus
        fields = '__all__'


class ShowInformationForm(FormWithButton):
    class Meta:
        model = ShowInformation
        fields = '__all__'


class ShowTopicForm(FormWithButton):
    class Meta:
        model = ShowTopic
        fields = '__all__'

program/templates/boxes/broadcastformat.html
{% if broadcastformat_list %}
    <dl id="broadcastformat" class="portlet">
        <dt class="portletHeader"><span>Legende</span></dt>
        {% for bf in broadcastformat_list %}
            <dd class="portletItem bcformat bf-{{ bf.slug }}">
                <a title="Sendungen mit dem Sendungsformat {{ bf.format }} anzeigen."
                   href="?broadcastformat={{ bf.slug }}">{{ bf.format }}</a>
            </dd>
        {% endfor %}
    </dl>
{% endif %}

program/templates/boxes/current.html
<!doctype html>
<html>
<head>
    <meta charset="utf-8"/>
    <title>Current program box</title>
</head>
<body>
{% if previous_timeslot or current_timeslot or next_timeslot or after_next_timeslot %}
    <dl id="program-current-box" class="portlet program-box">
        <dt class="portletHeader">Programm derzeit</dt>
        <dd class="portletItem">
            <table>
                <tr class="previous">
                    <td class="start">{{ previous_timeslot.start|date:"H:i" }}</td>
                    <td class="format bf-{{ previous_timeslot.show.broadcastformat.slug }}"
                        title="{{ previous_timeslot.show.broadcastformat.format }}">&nbsp;</td>
                    <td class="show">
                        <h3>
                            <a href="{% url "timeslot-detail" previous_timeslot.id %}">{{ previous_timeslot.show.name }}</a>
                        </h3>
                    </td>
                    <td class="show"></td>
                </tr>
                <tr class="current">
                    <td class="start">{{ current_timeslot.start|date:"H:i" }}</td>
                    <td class="format bf-{{ current_timeslot.show.broadcastformat.slug }}"
                        title="{{ current_timeslot.show.broadcastformat.format }}">&#x25B6;</td>
                    <td class="show">
                        <h3>
                            <a href="{% url "timeslot-detail" current_timeslot.id %}">{{ current_timeslot.show.name }}</a>
                        </h3>
                        {% if current_timeslot.note %}
                            <p>{{ current_timeslot.note.title }}</p>
                        {% else %}
                            <p>{{ current_timeslot.show.short_description }}</p>
                        {% endif %}
                    </td>
                </tr>
                <tr class="next">
                    <td class="start">{{ next_timeslot.start|date:"H:i" }}</td>
                    <td class="format bf-{{ next_timeslot.show.broadcastformat.slug }}"
                        title="{{ next_timeslot.show.broadcastformat.format }}">&nbsp;</td>
                    <td class="show">
                        <h3><a href="{% url "timeslot-detail" next_timeslot.id %}">{{ next_timeslot.show.name }}</a>
                        </h3>
                    </td>
                    <td class="show"></td>
                </tr>
                <tr class="after_next">
                    <td class="start">{{ after_next_timeslot.start|date:"H:i" }}</td>
                    <td class="format bf-{{ after_next_timeslot.show.broadcastformat.slug }}"
                        title="{{ after_next_timeslot.show.broadcastformat.format }}">&nbsp;</td>
                    <td class="show">
                        <h3>
                            <a href="{% url "timeslot-detail" after_next_timeslot.id %}">{{ after_next_timeslot.show.name }}</a>
                        </h3>
                    </td>
                    <td class="show"></td>
                </tr>
            </table>
        </dd>
    </dl>
{% endif %}
</body>
</html>

program/templates/boxes/musicfocus.html
{% if musicfocus_list %}
    <dl id="filterbox_musicfocus" class="portlet filterbox">
        <dt class="portletHeader"><span>Musiktendenz<span></dt>
        <dd class="portletItem">
            <ul>
                {% for mf in musicfocus_list %}
                    <li>
                        <a title="Sendungen mit der Musiktendenz {{ mf.focus }} anzeigen."
                           class="abbrev mf-{{ mf.abbrev }}" href="?musicfocus={{ mf.slug }}">{{ mf.focus }}</a>
                    </li>
                {% endfor %}
            </ul>
        </dd>
    </dl>
{% endif %}

program/templates/boxes/recommendation.html
<!doctype html>
<html>
<head>
    <meta charset="utf-8"/>
    <title>Recomendations box</title>
</head>
<body>
{% if recommendation_list %}
    <dl id="recommendations" class="portlet program-box">
        <dt class="portletHeader">Programmhinweise</dt>
        <dd class="portletItem">
            <table>
                {% for recommendation in recommendation_list %}
                    <tr>
                        <td class="start">&nbsp;</td>
                        <td class="format bf-{{ recommendation.show.broadcastformat.slug }}"
                            title="{{ recommendation.show.broadcastformat.format }}">&nbsp;</td>
                        <td class="show">
                            {{ recommendation.start|date:"d.m. H:i" }} - {{ recommendation.end|date:"H:i" }}<br/>
                            <h3>
                                <a href="{% url "timeslot-detail" recommendation.id %}">{{ recommendation.show.name }}</a>
                            </h3>
                            <p class="note-title">
                                {% if recommendation.note %}
                                    {{ recommendation.note.title }}<br/>
                                {% else %}
                                    {{ recommendation.show.broadcastformat.format }}<br/>
                                {% endif %}
                                <a href="{% url "timeslot-detail" recommendation.id %}">[weiter]</a>
                            </p>
                        </td>
                    </tr>
                {% endfor %}
            </table>
        </dd>
    </dl>
{% endif %}
</body>
</html>

program/templates/boxes/showinformation.html
{% if showinformation_list %}
    <dl id="filterbox_showinformation" class="portlet filterbox">
        <dt class="portletHeader"><span>Sendungsinfo<span></dt>
        <dd class="portletItem">
            <ul>
                {% for si in showinformation_list %}
                    <li>
                        <a title="Sendungen mit der Information {{ si.information }} anzeigen."
                           class="abbrev si-{{ si.abbrev }}"
                           href="?showinformation={{ si.slug }}">{{ si.information }}</a>
                    </li>
                {% endfor %}
            </ul>
        </dd>
    </dl>
{% endif %}

program/templates/boxes/showtopic.html
{% if showtopic_list %}
    <dl id="filterbox_showtopic" class="portlet filterbox">
        <dt class="portletHeader"><span>Thema / Schwerpunkt<span></dt>
        <dd class="portletItem">
            <ul>
                {% for showtopic in showtopic_list %}
                    <li>
                        <a title="Sendungen mit dem Schwerpunkt {{ showtopic.topic }} anzeigen."
                           class="abbrev st-{{ showtopic.abbrev }}"
                           href="?showtopic={{ showtopic.slug }}">{{ showtopic.topic }}</a>
                    </li>
                {% endfor %}
            </ul>
        </dd>
    </dl>
{% endif %}